#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	//ofBackground(199,113, 64);
	image.loadImage("waterfall.jpg");
	ofEnableAlphaBlending();
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	
	
	for (int i = 0; i < 150; i++){
		particle myParticle;
		myParticle.setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
		particles.push_back(myParticle);
	}
	
	
}

//--------------------------------------------------------------
void testApp::update(){
	
	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
	}
	
	for (int i = 0; i < particles.size(); i++){
		
		particles[i].addAttractionForce(mouseX, mouseY, 1000, 0.07f);
		
		for (int j = 0; j < i; j++){
			particles[i].addRepulsionForce(particles[j], 200, 0.001);
			particles[i].addCounterClockwiseForce(particles[j], 80, 0.09);
		}
	}
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].addDampingForce();
		particles[i].update();
	}
}

//--------------------------------------------------------------
void testApp::draw(){
	image.draw(0, 0);
	

	
	for (int i = 0; i < particles.size(); i++){
		particles[i].draw();
		particles[i].setInitialCondition(ofRandom(350, 700),ofRandom(0,ofGetHeight()),0,0);
	}
	

//			for (int i = 0; i < particles.size(); i++){
//				particles[i].draw();
//				particles[i].setInitialCondition(ofRandom(350, 700),ofRandom(0,ofGetHeight()),0,0);
//			}

	
//	ofFill();
//	ofBeginShape();
//	for (int i = 0; i < particles.size(); i++){
//		ofVertex(particles[i].pos.x, particles[i].pos.y);
//	}
//	ofEndShape();
	
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
//	switch (key){
//			
//		case ' ':
//			// reposition everything: 
//			for (int i = 0; i < particles.size(); i++){
//				particles[i].setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
//			}
//			break;
//	}
	
	
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	particles.erase(particles.begin());
	particle myParticle;
	myParticle.setInitialCondition(0,0,0,0);
	particles.push_back(myParticle);
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}
